#ifndef H_HD
#define H_HD

#include "devices.h"

enum partitionTypes { PART_EXT2, PART_SWAP, PART_DOS, PART_HPFS,
			PART_NFS, PART_FAT32, PART_OTHER, PART_IGNORE };

struct partition {
    char device[10];
    int size;				/* in 1k blocks */
    enum partitionTypes type;
    int begin;
    int end;
    char tagName[25];
    char * bootLabel;
    int defaultBoot;
} ;

struct partitionTable {
    struct partition * parts;
    int count;
};

int findAllPartitions(struct deviceInfo * devices, 
		      struct partitionTable * table);
int partitionDrives(void);
int getDriveList(char *** drives, int * num);

#endif
